package mockkeyvaluedriver

// A KeyValueStore implements methods to set key-value data (mock)
type KeyValueStore struct {
	data map[string]string
}

// CreateKeyValueStore creates a key value store driver (mock)
func CreateKeyValueStore() *KeyValueStore {
	return &KeyValueStore{
		data: make(map[string]string),
	}
}

// Set sets a key to a value in the key value store. Expects a non-pointer as value. (mock)
func (kvs *KeyValueStore) Set(key *string, value *string) error {
	kvs.data[*key] = *value
	return nil
}

// Get gets the value for the supplied key from the key value store (mock)
func (kvs *KeyValueStore) Get(key *string) string {
	return kvs.data[*key]
}
