package mockconvertquery

import "errors"

// A Service implements the query convert usecase interface (mock)
type Service struct {
	throwError bool
}

// NewService creates a new query convert service (mock)
func NewService() *Service {
	return &Service{
		throwError: false,
	}
}

// ConvertQuery returns a hard coded string message (mock)
func (s *Service) ConvertQuery(jsonMsg *[]byte) (*string, error) {
	mockQuery := "Query converted"

	if !s.throwError {
		return &mockQuery, nil
	}
	return nil, errors.New("Failed to convert query")
}

// ToggleError decides whether the convert function throws an error
func (s *Service) ToggleError() {
	s.throwError = !s.throwError
}
