package produce

import (
	"query-service/internal/drivers/brokerdriver"
	"query-service/internal/drivers/keyvaluedriver"
)

// Service wraps consumer methods
type Service struct {
	brokerDriver   brokerdriver.Broker
	keyValueStore  keyvaluedriver.KeyValueStoreInterface
	producerDriver brokerdriver.Producer
}

// NewService creates a new service
func NewService(broker brokerdriver.Broker, keyValueStore keyvaluedriver.KeyValueStoreInterface) *Service {
	return &Service{
		brokerDriver:  broker,
		keyValueStore: keyValueStore,
	}
}

// Start starts the producer
func (s *Service) Start() {
	// Create producer
	p := s.brokerDriver.CreateProducer()

	s.producerDriver = p
}
